package patrones.proxy.eje1;

/**
 * La clase Sujeto dentro del patrón Proxy es la interfaz del sujeto real de
 * cara al exterior (Cliente). Es una clase abstracta cuyos métodos serán
 * implementados tanto por el sujeto real como por el proxy.
 */

public abstract class Sujeto {
	/**
	 * La clase Sujeto tiene el atributo _nombre , que indica el nombre de un
	 * sujeto, tanto si se trata de un proxy como de un sujeto real.
	 */

	private String _nombre;

	/**
	 * El constructor guarda el nombre del sujeto.
	 */
	public Sujeto(String nombre) {
		_nombre = nombre;
	}

	/**
	 * Método que devuelve el nombre del sujeto.
	 */
	public String getNombre() {
		return _nombre;
	}

	/**
	 * Metodos definidos de forma abstracta en la clase Sujeto, y que tendran
	 * distintas implementaciones en las clases que heredan de esta: Proxy y
	 * SujetoReal.
	 */

	public abstract void metodo1();

	public abstract void metodo2();

}